Last Comment Bug 1210328 - The arrow icon for doorhanger panels is incorrectly placed while the browser is in full screen
: The arrow icon for doorhanger panels is incorrectly placed while the browser ...
Status: VERIFIED FIXED
:
Product: Core
Classification: Components
Component: XP Toolkit/Widgets: Menus (show other bugs)
: Trunk
: All All
-- normal (vote)
: mozilla52
Assigned To: Neil Deakin (not available until Aug 9)
:
:
Mentors:
: 1197446 (view as bug list)
Depends on: 1206133
Blocks: 1188400 1207419
  Show dependency treegraph
 
Reported: 2015-10-01 02:07 PDT by Petruta Rasa [QA] [:petruta]
Modified: 2016-10-21 16:00 PDT (History)
12 users (show)
See Also:
Crash Signature:
(edit)
QA Whiteboard: [good first verify]
Iteration: 52.2 - Oct 17
Points: ---
Has Regression Range: ---
Has STR: ---
affected
verified


Attachments
step3 anchor.png (18.83 KB, image/png)
2015-10-01 02:07 PDT, Petruta Rasa [QA] [:petruta]
no flags Details
Improve flip calculations (7.47 KB, patch)
2015-12-04 10:02 PST, Neil Deakin (not available until Aug 9)
no flags Details | Diff | Splinter Review
Improve flip calculations, v2 (7.58 KB, patch)
2016-10-05 07:04 PDT, Neil Deakin (not available until Aug 9)
ksteuber: review+
Details | Diff | Splinter Review

Description User image Petruta Rasa [QA] [:petruta] 2015-10-01 02:07:16 PDT
Created attachment 8668335 [details]
step3 anchor.png

Reproduced with Firefox 42 beta 2, Dev Ed 43.0a2 and Nightly 44.0a1 2015-09-30 under Win 7 32-bit and Ubuntu 14.04 32-bit.
Not reproducible under Mac OS X 10.9.5.

STR: 
1. Open a private window and select "See how this works" to enter tracking protection tour
2. Enter Full screen (F11)
3. Go to step 3 and check the panel

ER: The arrow is correctly placed while in full screen

AR: The arrow is shown on the bottom of the panel
Could be related to bug 1207536.
Comment 1 User image Brian Grinstead [:bgrins] 2015-10-01 08:08:15 PDT
(In reply to Petruta Rasa [QA] [:petruta] from comment #0)
> Created attachment 8668335 [details]
> step3 anchor.png
> 
> Reproduced with Firefox 42 beta 2, Dev Ed 43.0a2 and Nightly 44.0a1
> 2015-09-30 under Win 7 32-bit and Ubuntu 14.04 32-bit.
> Not reproducible under Mac OS X 10.9.5.
> 
> STR: 
> 1. Open a private window and select "See how this works" to enter tracking
> protection tour
> 2. Enter Full screen (F11)
> 3. Go to step 3 and check the panel
> 
> ER: The arrow is correctly placed while in full screen
> 
> AR: The arrow is shown on the bottom of the panel
> Could be related to bug 1207536.

Does this only happen in the Control Center during the UI Tour, or can you reproduce it when manually opening the Control Center?
Comment 2 User image Petruta Rasa [QA] [:petruta] 2015-10-02 01:20:51 PDT
I could only see it during the tour.
Comment 3 User image Petruta Rasa [QA] [:petruta] 2015-10-02 01:48:16 PDT
(In reply to Brian Grinstead [:bgrins] from comment #1)
> Does this only happen in the Control Center during the UI Tour, or can you
> reproduce it when manually opening the Control Center?

Actually, I could reproduce it on other pages too. Apparently the doorhanger must be activated from page content while the browser is full screen.
Other samples:
- http://mozilla.github.io/webrtc-landing/gum_test.html select any of the "Video", "Audio" or "Audio & Video" options
http://webaudioplayground.appspot.com/#/ choose "Live input" option
Comment 4 User image Neil Deakin (not available until Aug 9) 2015-12-04 10:02:10 PST
Created attachment 8695968 [details] [diff] [review]
Improve flip calculations

This patch improves detection of whether a flip was performed, by comparing the result to the original expected direction of the popup, rather than just guessing.

You may need the patch in bug 1206133 for this too in some cases.

Bug 1188400 may be fixed by both patches as well.
Comment 5 User image :Gijs 2016-02-16 09:27:26 PST
Neil, is this patch ready for review? What's the next step here?
Comment 6 User image :Gijs 2016-02-16 09:28:41 PST
*** Bug 1197446 has been marked as a duplicate of this bug. ***
Comment 7 User image Neil Deakin (not available until Aug 9) 2016-02-16 09:32:46 PST
It could be ready, but many cases wouldn't be fixed without bug 1206133, which itself has the problem that it breaks some tests.
Comment 8 User image Neil Deakin (not available until Aug 9) 2016-10-05 07:04:00 PDT
Created attachment 8798038 [details] [diff] [review]
Improve flip calculations, v2

This version has a minor fix for rtl.
Comment 9 User image Kirk Steuber [:bytesized] 2016-10-07 10:52:41 PDT
Comment on attachment 8798038 [details] [diff] [review]
Improve flip calculations, v2

Review of attachment 8798038 [details] [diff] [review]:
-----------------------------------------------------------------

Looks good!

::: layout/xul/nsMenuPopupFrame.cpp
@@ +1542,5 @@
>  
>      // Next, check if there is enough space to show the popup at full size when
>      // positioned at screenPoint. If not, flip the popups to the opposite side
>      // of their anchor point, or resize them as necessary.
> +    

Formatting nit: extra whitespace on line 1546
Comment 10 User image Neil Deakin (not available until Aug 9) 2016-10-11 11:17:27 PDT
https://hg.mozilla.org/integration/mozilla-inbound/rev/a9e9e6a3d7202b04ff2259f9f400739c1202c609
Bug 1210328, compute correct flip state for popups, r=ksteuber
Comment 11 User image Carsten Book [:Tomcat] 2016-10-12 03:06:20 PDT
https://hg.mozilla.org/mozilla-central/rev/a9e9e6a3d720
Comment 12 User image Sayed 2016-10-21 02:18:08 PDT
I have reproduced this bug with Nightly 44.0a1 (2015-10-01) in Elementary OS 64bit 

This bug's fix is now verified in Latest Nightly 52.0a1

Build ID 	20161020030211
User Agent 	Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101 Firefox/52.0

[testday-20161021]
Comment 13 User image Md.Majedul islam 2016-10-21 05:10:40 PDT
I have reproduced this bug with Nightly 44.0a1 (2015-10-01) in Windows 10, 64bit .

This bug's fix is now verified in Latest Nightly 52.0a1 (2016-10-20).

Build ID 	20161020030211
User Agent 	Mozilla/5.0 (Windows NT 10.0; WOW64; rv:52.0) Gecko/20100101 Firefox/52.0

[testday-20161021]

Note You need to log in before you can comment on or make changes to this bug.